#include "lolevel.h"
#include "platform.h"
#include "core.h"
#include "keyboard.h"


extern long link_bss_start;
extern long link_bss_end;
extern void boot();

void startup() {
    long *bss = &link_bss_start;
    // sanity check
    if ((long)&link_bss_end > (MEMISOSTART + MEMISOSIZE)) {
        started();
        shutdown();
    }
    // initialize .bss senment
    while (bss<&link_bss_end)
        *bss++ = 0;
    boot();
}

#define NUM_FL      101  // TODO PROBALY WRONG for SX720 locate Focus length table in firmware
#define NUM_DATA    2   // 2 words each entry, first is FL
extern int focus_len_table[NUM_FL*NUM_DATA];

// Conversion factor lens FL --> 35mm equiv   > WRONG THIS IS NOT FOR SX720 calculate it to 	24 > 960 mm
// lens      35mm     CF
// ----      ----     --
//  8.8      24       ( 24/ 8.8) * 110 = 300  (min FL)
// 36.8     100       (100/36.8) * 110 = 299  (max FL)
// SX720 Aprox where the 110 comes from?
//   8.8      24       ( 24/ 8.8) * 110 = 300  (min FL)
// 352.8     960       (960/352.8) * 110 = 299  (max FL)

#define CF_EFL      300  // probaly wrong too
#define CF_EFL_DIV  110 // probaly wrong too

const int zoom_points = NUM_FL;

int get_effective_focal_length(int zp) {
    return (CF_EFL*get_focal_length(zp))/CF_EFL_DIV;
}

int get_focal_length(int zp) {
    if (zp < 0) zp = 0;
    else if (zp >= NUM_FL) zp = NUM_FL-1;
    return focus_len_table[zp*NUM_DATA];
}

int get_zoom_x(int zp) {
    return get_focal_length(zp)*10/focus_len_table[0];
}


long get_vbatt_min()
{
    return 3200; // shutdown around 3100  all this is g7x data
}


long get_vbatt_max()
{
    return 4060;  // original battery just charged all this is g7x data
}
