#include "stubs_asm.h"

// BEWARE: thumb functions NEED the thumb bit in the below list

#define NULL_SUB	0xfc0216ed  // SX720 OK-2 in g7x  0xfc0212a5	// bx lr
#define RET1		0xfc001edf  // SX720 OK-2 in g7x 0xfc001eeb	// mov r0, #1 ; bx lr
#define RET0		0xfc000975  // SX720 OK-2 in g7x 0xfc000981	// mov r0, #0 ; bx lr

NHSTUB(Feof_Fut,								0xfc32de37) // SX720 OK-2 g7x: 0xfc325d21 from CreateJumptable, after Fseek
NHSTUB(Fflush_Fut,								0xfc32de61) // SX720 OK-2 g7x: 0xfc325d49 directly after Feof_Fut in ROM
NHSTUB(displaybusyonscreen,                   	0xfc307c1d) // SX720 OK-2   fc332b90 looks like ScreenUnlock g7x: 0xfc34586d 0xfc356638 ref _PBBusyScrn  
NHSTUB(undisplaybusyonscreen,                 	0xfc307cb5) //  SX720 OK-2 g7x: 	0xfc345905  near display* above 
NHSTUB(SetFileTimeStamp,						0xfc333309) // SX720 OK-2 g7x: 0xfc3582d1 from ref to 0x12cea600 @0xfc3582e4, similar to sx280hs
NHSTUB(SetFileAttributes,						0xfc333369) // SX720 OK-2 looks like a bit diff prev g7x: 0xfc358319 function following SetFileTimeStamp in ROM
NHSTUB(RenameFile_Fut,							0xfc32dbe9) // SX720 OK-2 g7x:0xfc325ad1 from ref to ".RPC" @0xfc11019a, similar to sx280hs
NHSTUB(MakeSDCardBootable,						0xfc33716d) // SX720 OK-2 g7x: 0xfc357f65 in function before ref to "SCRIPT" @0xfc357b78
// TODO unverfied
NHSTUB(GetFocusLensSubjectDistanceFromLens,		0xfc32f367) // SX720 OK-2 like in g7x:0xfc31fdfd) call at 0xfc305ef0 similar to sx280 0xfc26ea22, from earlier ISDriver.c assert
// based on ref to fc32190b -> sub_fc469ee2, which refs  "___%02d" and "_%02d%02d"
NHSTUB(GetImageFolder,							0xfc31c09b) // SX720 OK-2 g7x:fc320ebf
NHSTUB(apex2us,									0xfc358cd7) // SX720 OK-2 g7x: 0xfc382687 Shutter.c asserts in sub_fc16e57e, similar to sx280 sub_fc2a63d6
NHSTUB(GetDrive_TotalClusters,					0xfc336da7) // SX720 OK-2 g7x: 0xfc357bd7 function immediately before GetDrive_FreeClusters in ROM
NHSTUB(LogCameraEvent,							0xfc341713)  // SX720 OK-2 g7x: 0xfc36000b debugging, from func csv
NHSTUB(CancelHPTimer,							0xfc1548c8) // SX720 OK-2 g7x: 0xfc158e24 At 0xfc0cd6b0, following LcdSequence, TakeSemaphoreStrictly calls similar to sx280

NHSTUB(get_dial_hw_position,					0xfc1af3ad) // SX720 Looks LIKE OK-2 GX7 WAS: 0xfc491e7d  kbd_p1_f_cont->fc077438->fc075c1c->func 4=rear dial, 5=front dial

// required because DryOS >=54 functions assert on unitialized event flag, sem etc 
// see https://chdk.setepontos.com/index.php?topic=12516.0
NHSTUB(init_focus_eventflag,	0xfc55421b) //  SX720 OK-2 g7x:fc4f3bd7 InitializeAdjustmentSystem->fc3d31c4->fc4f3bd6 event flag matches MoveFocusLensToDistance
NHSTUB(init_nd_eventflag, 0xfc554325) //  SX720 OK-2 g7x:fc4f3ce9 InitializeAdjustmentSystem->fc3d31c4->fc4f3ce8 event flag matches PutInNdFilter

// this is wrongly detected as Close 
NHSTUB(CreateBinarySemaphoreStrictly,0xbfe155f5) // SX720 in g7x was in ram 0x010e5bb7 for av_override_semaphore
//NHSTUB(Close,0xfc427fb7) // SX720 
//NHSTUB(close,0xfc427fb7) // SX720 
//NHSTUB(Close_FW,0xfc427fb7) // SX720 


// SX720 OK  NOT in _2 from g7x

NHSTUB(ScreenLock,0xfc332b59) 			// Sx720 OK-2
NHSTUB(ScreenUnlock,0xfc332b91)
NHSTUB(LocalTime,0x010e1581)
NHSTUB(PT_PlaySound,0xfc349d89)
NHSTUB(strtolx ,0xfc159981)  // Looks like but the ;fc15 is a bit earlier
NHSTUB(TurnOffBackLight,NULL_SUB) //  WRONG SX700 did not find yet
NHSTUB(TurnOnBackLight,NULL_SUB) //  SX700 Probably 0xbfe1565d from j_TurnOnBackLight but not sure


// TODO temp for compile
NHSTUB(EnterToCompensationEVF,NULL_SUB)
NHSTUB(ExitFromCompensationEVF,NULL_SUB)
NHSTUB(ExpCtrlTool_StartContiAE,NULL_SUB)
NHSTUB(ExpCtrlTool_StopContiAE,NULL_SUB)
NHSTUB(RefreshPhysicalScreen,NULL_SUB)
NHSTUB(Restart,NULL_SUB)
NHSTUB(SetParameterData,NULL_SUB)
NHSTUB(WriteSDCard,NULL_SUB)
NHSTUB(reboot_fw_update,NULL_SUB)

// from sx280 These don't exist
NHSTUB(SetZoomActuatorSpeedPercent, NULL_SUB)
NHSTUB(UnsetZoomForMovie,           NULL_SUB)